﻿using UnityEngine;
using UnityEngine.Events;

namespace niche
{
	public class niche
	{
		public static void Main()
		{
			ModAPI.Register(new Modification() // Regeneration Syringe
			{
				OriginalItem = ModAPI.FindSpawnable("Life Syringe"), //Base item, in this case a syringe.
				NameOverride = "Regenerative Syringe -FK",
				NameToOrderByOverride = "FK0",
				DescriptionOverride = "Probably a life syringe that was meant to be thrown out... Oh well! Finders keepers!", //Witty description
				CategoryOverride = ModAPI.FindCategory("Biohazard"),
				ThumbnailOverride = ModAPI.LoadSprite("thumb.png"),
				AfterSpawn = (System.Action<GameObject>)(Instance =>  //all code in the AfterSpawn delegate will be executed when the item is spawned
				{
					UnityEngine.Object.Destroy((UnityEngine.Object)Instance.GetComponent<LifeSyringe>());
					Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("regensyr.png"); //get the SpriteRenderer and replace its sprite with a custom one
					Instance.GetComponent<SpriteRenderer>().color = Color.white;
					Instance.AddComponent<RegenSyringe>();
				})
			});
			ModAPI.Register(new Modification() // Regen Syringe without awake
			{
				OriginalItem = ModAPI.FindSpawnable("Life Syringe"), //Base item, in this case a syringe.
				NameOverride = "Bootleg Regen Syringe -FK",
				NameToOrderByOverride = "FK1",
				DescriptionOverride = "A regeneration syringe that has expired... I don't think it regenerates brain cells...?", //Witty description
				CategoryOverride = ModAPI.FindCategory("Biohazard"),
				ThumbnailOverride = ModAPI.LoadSprite("BrainThumb.png"),
				AfterSpawn = (System.Action<GameObject>)(Instance =>  //all code in the AfterSpawn delegate will be executed when the item is spawned
				{
					UnityEngine.Object.Destroy((UnityEngine.Object)Instance.GetComponent<LifeSyringe>());
					Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("brainregsyr.png"); //get the SpriteRenderer and replace its sprite with a custom one
					Instance.GetComponent<SpriteRenderer>().color = Color.white;
					Instance.AddComponent<BrainRegSyringe>();
				})
			});
			ModAPI.Register(new Modification() // Regen Syringe without awake
			{
				OriginalItem = ModAPI.FindSpawnable("Life Syringe"), //Base item, in this case a syringe.
				NameOverride = "Coma -FK",
				NameToOrderByOverride = "FK2",
				DescriptionOverride = "I don't think this is ethical to inject without doctor orders.", //Witty description
				CategoryOverride = ModAPI.FindCategory("Biohazard"),
				ThumbnailOverride = ModAPI.LoadSprite("ComaThumb.png"),
				AfterSpawn = (System.Action<GameObject>)(Instance =>  //all code in the AfterSpawn delegate will be executed when the item is spawned
				{
					UnityEngine.Object.Destroy((UnityEngine.Object)Instance.GetComponent<LifeSyringe>());
					Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("comasyr.png"); //get the SpriteRenderer and replace its sprite with a custom one
					Instance.GetComponent<SpriteRenderer>().color = Color.white;
					Instance.AddComponent<ComaSyringe>();
				})
			});
		}
	}
}
