﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

public class RegenPoison : PoisonSpreadBehaviour
{
    int delay = 3, oDelay;
    

    public bool InstantRegen = false;



    public override void Start()
    {
        oDelay = delay;
        this.GeneralHealing();
        this.StartCoroutine(this.HealBurn(this.Limb));
        this.StartCoroutine(this.HealBulletHoles(this.Limb));
        this.StartCoroutine(this.HealWounds(this.Limb));
        this.StartCoroutine(this.HealRottenFlesh(this.Limb));
        this.StartCoroutine(this.HealAcidFlesh(this.Limb));
        this.StartCoroutine(Debug());
        this.StartCoroutine(Delay());
    }

    public override float Lifespan
    {
        get
        {
            return float.PositiveInfinity;
        }
    }

        public IEnumerator Debug()
    {
        while (true)
        {
            yield return new WaitForSeconds(1);
        }

    }

    public IEnumerator Delay()
    {
        while (true)
        {
            if (this.Limb.Health != this.Limb.InitialHealth)
            {
                if (delay >= oDelay)
                {
                    GeneralHealing();
                    delay = 0;
                }
                else { delay += 1; }
            }
            else
            { delay = 0; }
            yield return new WaitForSeconds(1);
        }

    }

    private void GeneralHealing()
    {
        this.Limb.HealBone();
        this.Limb.Health = this.Limb.InitialHealth;
        this.Limb.Numbness = 0.0f;
        this.Limb.CirculationBehaviour.HealBleeding();
        this.Limb.CirculationBehaviour.IsPump = this.Limb.CirculationBehaviour.WasInitiallyPumping;
        this.Limb.CirculationBehaviour.BloodFlow = 5f;
        this.Limb.CirculationBehaviour.BloodAmount = 5f;
        this.Limb.BruiseCount = (ushort)0;
        this.Limb.CirculationBehaviour.GunshotWoundCount = (ushort)0;
        this.Limb.CirculationBehaviour.StabWoundCount = (ushort)0;
        this.StopAllCoroutines();
        this.StartCoroutine(this.HealBurn(this.Limb));
        this.StartCoroutine(this.HealBulletHoles(this.Limb));
        this.StartCoroutine(this.HealWounds(this.Limb));
        this.StartCoroutine(this.HealRottenFlesh(this.Limb));
        this.StartCoroutine(this.HealAcidFlesh(this.Limb));
        this.StartCoroutine(Delay());
        delay = 0;
        if (this.Limb.RoughClassification != LimbBehaviour.BodyPart.Head)
            return;
        this.Limb.Person.Consciousness = 1f;
        this.Limb.Person.ShockLevel = 0.0f;
        this.Limb.Person.PainLevel = 0.0f;
        this.Limb.Person.OxygenLevel = 1f;
        this.Limb.Person.AdrenalineLevel = 1f;
    }

    private IEnumerator HealBurn(LimbBehaviour limb)
    {
        while ((double)limb.PhysicalBehaviour.BurnProgress > 0.100000001490116)
        {
            limb.PhysicalBehaviour.BurnProgress -= Time.deltaTime * 0.6f;
            yield return (object)new WaitForEndOfFrame();
        }
        limb.PhysicalBehaviour.BurnProgress = 0.0f;
    }

    private IEnumerator HealAcidFlesh(LimbBehaviour limb)
    {
        while ((double)limb.SkinMaterialHandler.AcidProgress > 0.100000001490116)
        {
            limb.SkinMaterialHandler.AcidProgress -= Time.deltaTime * 0.6f;
            yield return (object)new WaitForEndOfFrame();
        }
        limb.SkinMaterialHandler.AcidProgress = 0.0f;
    }

    private IEnumerator HealRottenFlesh(LimbBehaviour limb)
    {
        while ((double)limb.SkinMaterialHandler.RottenProgress > 0.100000001490116)
        {
            limb.SkinMaterialHandler.RottenProgress -= Time.deltaTime * 0.6f;
            yield return (object)new WaitForEndOfFrame();
        }
        limb.SkinMaterialHandler.RottenProgress = 0.0f;
    }

    private IEnumerator HealBulletHoles(LimbBehaviour limb)
    {
        while ((double)((IEnumerable<Vector4>)limb.SkinMaterialHandler.bulletHolePoints).Min<Vector4>((Func<Vector4, float>)(c => c.z)) < 50.0)
        {
            for (int index = 0; index < limb.SkinMaterialHandler.bulletHolePoints.Length; ++index)
            {
                limb.SkinMaterialHandler.bulletHolePoints[index].z = Mathf.Max(limb.SkinMaterialHandler.bulletHolePoints[index].z, 0.6f);
                limb.SkinMaterialHandler.bulletHolePoints[index].z += Time.deltaTime * 1f;
            }
            limb.SkinMaterialHandler.Sync();
            yield return (object)new WaitForEndOfFrame();
        }
    }

    private IEnumerator HealWounds(LimbBehaviour limb)
    {
        while ((double)((IEnumerable<Vector4>)limb.SkinMaterialHandler.damagePoints).Min<Vector4>((Func<Vector4, float>)(c => c.z)) < 50.0)
        {
            for (int index = 0; index < limb.SkinMaterialHandler.damagePoints.Length; ++index)
                limb.SkinMaterialHandler.damagePoints[index].z += Time.deltaTime * 0.6f;
            limb.SkinMaterialHandler.Sync();
            yield return (object)new WaitForEndOfFrame();
        }
    }
}